using System;
using System.Windows;
using CODE.Framework.Wpf.Mvvm;

namespace MagazineManagement.Models.Home
{
    public class StartViewModel : ViewModel
    {
        public static StartViewModel Current { get; set; }

        public StartViewModel()
        {
            Current = this;
        }

        public void LoadActions()
        {
            Actions.Clear();

            Actions.Add(new ViewAction("Manage Subscribers", execute: (a, o) => Controller.Action("Subscriber", "List"), significance: ViewActionSignificance.AboveNormal, category: "File", categoryAccessKey: 'F', accessKey: 'S', brushResourceKey: "CODE.Framework-Icon-People"));
            Actions.Add(new ViewAction("Magazines", execute: (a, o) => Controller.Action("Magazine", "Issues"), significance: ViewActionSignificance.AboveNormal, category: "File", categoryAccessKey: 'F', accessKey: 'M', brushResourceKey: "CODE.Framework-Icon-Page2"));

            Actions.Add(new SwitchThemeViewAction("Workplace", "Workplace", category: "View", categoryAccessKey: 'V', accessKey: 'W'));
            Actions.Add(new SwitchThemeViewAction("Metro", "Metro", category: "View", categoryAccessKey: 'V', accessKey: 'M'));
            Actions.Add(new SwitchThemeViewAction("Battleship", "Windows 95", category: "View", categoryAccessKey: 'V', accessKey: 'W'));
            Actions.Add(new SwitchThemeViewAction("Vapor", "Vapor", category: "View", categoryAccessKey: 'V', accessKey: 'V'));
            Actions.Add(new SwitchThemeViewAction("Geek", "Geek", category: "View", categoryAccessKey: 'V', accessKey: 'G'));
            //Actions.Add(new SwitchThemeViewAction("Pastel", "Pastel", category: "View", categoryAccessKey: 'V', accessKey: 'P'));
            //Actions.Add(new SwitchThemeViewAction("Wildcat", "Wildcat", category: "View", categoryAccessKey: 'V', accessKey: 'C'));
            //Actions.Add(new SwitchThemeViewAction("Superflex", "Superflex", category: "View", categoryAccessKey: 'V', accessKey: 'S'));

            // Example status updates
            Actions.Add(new ViewAction("Set Ready Status", category: "Status", categoryAccessKey: 'S', accessKey: 'R', execute: (a, o) => Controller.Status("Ready.")));
            Actions.Add(new ViewAction("Set Processing Status", category: "Status", execute: (a, o) => Controller.Status("Pretending to load data...", ApplicationStatus.Processing)));
            Actions.Add(new ViewAction("Set Warning Status", category: "Status", execute: (a, o) => Controller.Status("Maybe there is an issue you should pay attention to...", ApplicationStatus.Warning), accessKey: 'W'));
            Actions.Add(new ViewAction("Set Error Status", category: "Status", execute: (a, o) => Controller.Status("A serius problem has occured!", ApplicationStatus.Error), accessKey: 'E'));

            // Example notifications
            Actions.Add(new ViewAction("Short Notification", category: "Notifications", categoryAccessKey: 'N', execute: (a, o) => Controller.Notification("Subscriber Alert", "A new subscriber has been added to the system.", imageResource: "CODE.Framework-Icon-Message")));
            Actions.Add(new ViewAction("Long Notification", category: "Notifications", execute: (a, o) => Controller.Notification("Content Alert", "At " + DateTime.Now.ToString() + " new content has been added to the system. Lorem ipsum dolor sit amet, consectetur adipiscing elit. In tortor lectus, ultricies sed dictum vitae, tempor eget magna. Vivamus vitae libero at nunc tincidunt lobortis. Integer facilisis vehicula leo in luctus. Aenean vel nunc non orci consequat lacinia sed semper est. Pellentesque nec sapien dolor. Duis rhoncus aliquam interdum. Integer at velit at massa vulputate porttitor. Mauris neque nisl, cursus eu mollis varius, ultrices non dolor. Suspendisse potenti. Integer at rutrum ipsum. Curabitur sed augue massa. Donec luctus nunc non nunc sagittis eget venenatis velit interdum.", imageResource: "CODE.Framework-Icon-Message")));
        }
    }
}
