using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Threading;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using CODE.Framework.Wpf.Mvvm;

namespace MagazineManagement.Models.Magazine
{
    public class IssuesViewModel : ViewModel
    {
        public IssuesViewModel()
        {
            Issues = new ObservableCollection<StandardViewModel>();
            Actions.Add(new ViewAction("Print", brushResourceKey: "CODE.Framework-Icon-Print", execute: (a, o) => Controller.Action("Magazine", "Print", new {model = this}), significance: ViewActionSignificance.Highest));
            Actions.Add(new CloseCurrentViewAction(this, beginGroup: true) { Significance = ViewActionSignificance.Highest });
            Search = new ViewAction("Search", execute: (o, a) => LoadData());
        }

        private void LoadData()
        {
            AsyncWorker.Execute(() =>
                {
                    var result = new List<StandardViewModel>
                        {
                            new StandardViewModel {Identifier2 = "31D78235-2B61-469B-A080-790F8179CBF4", Text1 = "2013 May/Jun", Text2 = "So many technologies so little time. Sometimes we need to just put together a grab bag of articles exploring new technology and development techniques. This issue has content for everyone. Curious about TypeScript ? Considering building an application usin"},
                            new StandardViewModel {Identifier2 = "72966380-3A2C-4156-89A9-0EECE143DBFD", Text1 = "2013 Mar/Apr", Text2 = "Knowledge of JavaScript is a requirement for any modern web developer, but there's a new twist in Windows 8! You can build Windows 8 applications using JavaScript as well. This issue explores some new ideas in building apps with JavaScript as well as our u"},
                            new StandardViewModel {Identifier2 = "B1DD56F7-18C6-4D87-AF2D-C4D6BD3F3503", Text1 = "2013 Jan/Feb", Text2 = "In this issue we explore cloud computing. Take a look at examples from Windows Azure and Amazon Web Services. "},
                            new StandardViewModel {Identifier2 = "DCEBFBAC-32FA-4105-8525-C2B7B25A56FA", Text1 = "2012 Nov/Dec", Text2 = "Visual Studio 2012 is finally here! This issue will cover numerous improvements to Visual Studio 2012 including: IDE Changes, .NET Framework enhancements, web development changes. Join is as we uncover features that will make your life better."},
                            new StandardViewModel {Identifier2 = "FF09319A-75C8-40DE-B038-29EE723FB730", Text1 = "2012 Sep/Oct", Text2 = "We are in a golden age of innovation in the web development space. This issue demonstrates using some of the most current and useful tools for building web applications. Check out our articles on HTML5, Web Sockets and node.js!"},
                            new StandardViewModel {Identifier2 = "3C9B2830-C6DF-482C-8F3F-B4F0BC4092C9", Text1 = "2012 Jul/Aug", Text2 = "The world of software development is fertile soil. From the seeds of ideas sprouts of innovation bloom. In this issue we take a look at some of these new sprouts. We look at the newly budding field of bid data and the multi color field of dreams that is Wi"},
                            new StandardViewModel {Identifier2 = "314BA996-65D8-4649-9D88-714ECF3AB055", Text1 = "2012 May/Jun", Text2 = "The world of software development is dynamic. Change is a way of life. One of the recent changes in the last 10+ years is the widespread adoption of dynamic languages. This issue is dedicated to the exploration of the techniques and concepts used when buil"},
                            new StandardViewModel {Identifier2 = "629E17DD-6B32-4A99-8E25-C573132BD723", Text1 = "2012 Mar/Apr", Text2 = "In the last couple of years data has experienced a new Renaissance. We are no longer limited to the staid world of SQL, rows and columns. We now have document databases, columnar data stores, key value pair systems and many other new flavors of data. This "},
                            new StandardViewModel {Identifier2 = "95E105E4-7E4A-4B2F-B156-918B53900CAC", Text1 = "2012 Jan/Feb", Text2 = "Contrary to popular opinion, rich application development is not dead. Desktop and rich application development has been around for many years now and we see no end for that style. This issue covers a number of rich application development tools including "},
                            new StandardViewModel {Identifier2 = "1E01A1AA-F5D4-4107-993B-3493F20B016A", Text1 = "2011 Nov/Dec", Text2 = "Is your application distributed? Does your application have online and offline capabilities? Is your application ready for the present and future? This issue takes you through a number of technologies that you need to be aware of when building today's appl"},
                            new StandardViewModel {Identifier2 = "E47D2DDC-FDE8-45E6-A223-B01AFD4B90F4", Text1 = "2011 Sep/Oct", Text2 = "There are 100's of millions of mobile phones in consumers hands today. Each platform (IOS, Android and Windows Phone 7) has its own set of development tools and techniques. In this issue you will learn how to develop native applications for each platform."},
                            new StandardViewModel {Identifier2 = "CBEDF8A4-0D4E-472C-A955-C008BAA468D2", Text1 = "2011 Jul/Aug", Text2 = " If you are a web developer you have probably heard about numerous web technologies. PHP, Ruby on Rails,HTML5 and ASP MVC. In this issue we take a look at them all!"},
                            new StandardViewModel {Identifier2 = "17F4B1FF-3FC9-4AA5-92B5-1B19AB3BB216", Text1 = "2011 May/Jun", Text2 = "JavaScript comes in many colors and flavors. In this issue you will learn about using JavaScript in your web applications. Learn plug in development with jQuery UI, examine object oriented concepts with Mootools and explore the world of Async javascript wi"},
                            new StandardViewModel {Identifier2 = "D98918DA-1656-4299-A82D-6CD310DC7F43", Text1 = "2011 Mar/Apr", Text2 = "This issue of CODE Magazine focuses on LightSwitch.  Learn what LightSwitch is and why you should care! "},
                            new StandardViewModel {Identifier2 = "1EFB531E-ADE2-4600-88C3-3C20BC2203B1", Text1 = "2011 Jan/Feb", Text2 = "Code - The Leading Independent .NET Magazine - Featuring articles on Windows Phone 7, Silverlight, PLINQ, PowerPivot, SQL Server"},
                            new StandardViewModel {Identifier2 = "46C54B07-59E9-42E1-8825-3CF02C307C28", Text1 = "2010 Nov/Dec", Text2 = "Code - The Leading Independent .NET Magazine featuring articles on MVC3, WPF, Silverlight, MVVM and Iron Ruby"},
                            new StandardViewModel {Identifier2 = "B93AEF06-0C65-4977-B997-941B18D56301", Text1 = "2010 Sep/Oct", Text2 = "Code - The Leading Independent .Net Magazine "},
                            new StandardViewModel {Identifier2 = "08CFFCE0-AC39-4C3D-AF94-0E30146C55DC", Text1 = "2010 Jul/Aug", Text2 = "Code - The Leading Independent .NET Magazine - WPF, SSIS, Dynamics CRM, Reporting Services, Git"},
                            new StandardViewModel {Identifier2 = "007EBDB0-1FB3-4BD4-91E5-5EA3FA16D665", Text1 = "2010 May/Jun", Text2 = "Code - The Leading Independent .NET Resource - 10 Years of CODE and Visual Studio, WCF 5, Bing, Ruby, Sharepoint"},
                            new StandardViewModel {Identifier2 = "1F5D60E7-B260-462C-AC41-56A8CB898892", Text1 = "2010 Mar/Apr", Text2 = "Code - The Leading Independent .NET Resource"},
                            new StandardViewModel {Identifier2 = "07EB54E6-16C1-4681-8D5E-824096A6F77A", Text1 = "2010 Jan/Feb", Text2 = "Code - The Leading Independent .NET Resource"},
                            new StandardViewModel {Identifier2 = "BBC7F00A-5FD4-4FCF-94C6-01915CBC439E", Text1 = "2009 Nov/Dec", Text2 = "CoDe Magazine  the Leading Independent Magazine for .NET Developers"},
                            new StandardViewModel {Identifier2 = "05B229FE-C2DB-406F-A0F0-69F32594E34C", Text1 = "2009 Sep/Oct", Text2 = "This issue of CODE Magazine features a number of articles on Service and Server technologies, including REST, Twitter Programming, Entity Framework 4, Windows Azure, and more. As always, the issue also features other .NET programming topics."},
                            new StandardViewModel {Identifier2 = "69CD6FE0-4945-4840-9FA4-9E2829F80ADE", Text1 = "2009 Jul/Aug", Text2 = "This issue of CODE Magazine focusses on WPF and Silverlight development among other topics."},
                            new StandardViewModel {Identifier2 = "EDB7D052-D9AA-4755-85D4-548C35DA2FE2", Text1 = "2009 May/Jun", Text2 = "CoDe Magazine  the Leading Independent Magazine for .NET Developers"},
                            new StandardViewModel {Identifier2 = "FD61C741-1A59-49DD-8C9D-C59F94F2AB64", Text1 = "2009 Mar/Apr", Text2 = "CoDe Magazine  the Leading Independent Magazine for .NET Developers.  Get the Key to Web 2.0"},
                            new StandardViewModel {Identifier2 = "9FE14579-8444-4263-8B12-5596C731CA54", Text1 = "2009 Jan/Feb", Text2 = "The Jan/Feb 09 issue covers .NET Productivity Tools."},
                            new StandardViewModel {Identifier2 = "CA132A10-C0EB-4BD5-AD9B-D33E2D8CC22B", Text1 = "2008 Nov/Dec", Text2 = "WPF and Silverlight"},
                            new StandardViewModel {Identifier2 = "E3B92E0B-1EC4-49D5-A4FB-4C8D4A6D4311", Text1 = "2008 Sep/Oct", Text2 = "Discover the New .NET Languages!"},
                            new StandardViewModel {Identifier2 = "B080EECF-CCB9-4498-B386-5F37AD20EDDB", Text1 = "2008 Jul/Aug", Text2 = "Visual Studio and SQL Server 2008"},
                            new StandardViewModel {Identifier2 = "4659D960-1235-4848-AEB3-A02C1A441300", Text1 = "2008 May/Jun", Text2 = "Agile Development"},
                            new StandardViewModel {Identifier2 = "EE29B47A-45C4-416B-BDF0-FD5EAE64B30E", Text1 = "2008 Mar/Apr", Text2 = "Rich User Interfaces"},
                            new StandardViewModel {Identifier2 = "C5B37750-95D9-4266-82DB-8A542284052A", Text1 = "2008 Jan/Feb", Text2 = "The January / February 2008 issue focuses on improving application productivity."},
                            new StandardViewModel {Identifier2 = "49BE38BE-AEB8-48E1-8F5E-943D009C24E8", Text1 = "2007 Nov/Dec", Text2 = "The Nov/Dec 2007 issue of CoDe Magazine - covers .NET 3.5"},
                            new StandardViewModel {Identifier2 = "F203B232-9DE5-4802-8E55-F50A686C4A24", Text1 = "2007 Sep/Oct", Text2 = "The Sept/Oct 2007 issue of CoDe Magazine focuses on XNA: Ready for Prime Time?"},
                            new StandardViewModel {Identifier2 = "54A3FF0D-5089-4EEE-BF14-9A7265567F59", Text1 = "2007 - Jul/Aug", Text2 = "The July / August 2007 issue of CoDe Magazine focuses on Windows Forms."},
                            new StandardViewModel {Identifier2 = "0ED3D8D4-4769-488E-A7EE-68A0D638CE45", Text1 = "2007 - May/Jun", Text2 = "The May / June 2007 issue of CoDe Magazine focuses on Enterprise Development."},
                            new StandardViewModel {Identifier2 = "EF276B17-1ADF-4406-B7C7-7993D98ABDDE", Text1 = "2007 - Mar/Apr", Text2 = "The March / April issue of CoDe magazine takes a look at the various underlying plumbing needed when building .NET Applications"},
                            new StandardViewModel {Identifier2 = "55F20D65-1F60-40F2-A652-34A6C914C0FB", Text1 = "2007 - Jan/Feb", Text2 = "The January/February 2007 issue of CoDe Magazine Focuses on Reporting."},
                            new StandardViewModel {Identifier2 = "0BC222C4-7A05-442A-B2BA-C81C457725BF", Text1 = "2006 - Nov/Dec", Text2 = "The November/December 2006 issue of CoDe Magazine Focuses on Emerging Technologies"},
                            new StandardViewModel {Identifier2 = "133F6507-F2F9-4B37-AD14-DCA9FAB1C53D", Text1 = "2006 - Sep/Oct", Text2 = "The September/October 2006 issue of CoDe Magazine focuses on ASP.NET 2.0."},
                            new StandardViewModel {Identifier2 = "52D5D86E-170C-47A4-AC00-0A2CB84C60E7", Text1 = "2006 - Jul/Aug", Text2 = "The July/August 2006 issue of CoDe Magazine focuses on Data.  Articles include tips on managing data, data access in Visual Studio 2005 and handling database concurrency conflicts."},
                            new StandardViewModel {Identifier2 = "8AF696BB-EDB8-4506-BFEA-F752B1C5FB71", Text1 = "2006 - May/Jun", Text2 = "The May/June issue of CoDe Magazine covers distributed computing topics, such as the Windows Communication Foundation (WCF... formerly known as 'Indigo'), as well as other, more general .NET development topics."},
                            new StandardViewModel {Identifier2 = "259208CA-74C4-418E-82BB-AEEDCF25DF64", Text1 = "2006 - Mar/Apr", Text2 = "The March/April 2006 issue of CoDe Magazine focuses on upcoming technologies such as Windows Presentation Foundation (WPF, formerly known as 'Avalon'), and LINQ (Language Integrated Query). The magazine also has a number of articles on current technologies"},
                            new StandardViewModel {Identifier2 = "5C6CA741-1247-42CD-B74C-510FB7BDA376", Text1 = "2006 - Jan/Feb", Text2 = "The Jan/Feb issue of CoDe Magazine focuses on Windows and Multi-Media development, as well as topics of general interest"},
                            new StandardViewModel {Identifier2 = "F7DDAA17-649A-46D9-BB76-258D7F5E9A4E", Text1 = "2005 - Nov/Dec", Text2 = "This November/December issue covers VS 2005"},
                            new StandardViewModel {Identifier2 = "7F09233A-A6ED-4DD8-916E-EA8E930127AE", Text1 = "2005 - Sep/Oct", Text2 = "The September/October issue of CoDe Magazine discusses ASP.NET among other topics."},
                            new StandardViewModel {Identifier2 = "05552FB7-160C-4601-8991-5F28AB7F1BF7", Text1 = "2005 - Jul/Aug", Text2 = "The July/August  issue discusses enterprise development techniques."},
                            new StandardViewModel {Identifier2 = "E6E45D29-180D-4C2E-BE41-186DC694CC18", Text1 = "2005 - May/Jun", Text2 = "The May/June issue discusses programming best practices. This is also the 5-year anniversary edition of CoDe Magazine."},
                            new StandardViewModel {Identifier2 = "09388955-611A-40C2-9634-1A15B884CF08", Text1 = "2005 - Mar/Apr", Text2 = "The Mar/Apr issue of Code Magazine targets ASP.NET."},
                            new StandardViewModel {Identifier2 = "867B1E23-C0B5-4753-AAF4-D904854535F3", Text1 = "2005 - Jan/Feb", Text2 = "The November/December issue of CoDe Magazine is focused on SQL Server 2005 and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "2BF859B4-5C48-4E5E-A353-64D18346C58C", Text1 = "2004 - November/December", Text2 = "The November/December issue of CoDe Magazine is focused on Unit Testing and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "F5FB5A19-2076-4C03-A41D-838A9A289106", Text1 = "2004 - September/October", Text2 = "The September/October issue of CoDe Magazine is focused on Visual Studio 2005, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "890651EC-01B9-4457-88A8-64EE16C7D06C", Text1 = "2004 - July/August", Text2 = "The July/August issue of Component Developer Magazine (CoDe) is focused on SQL Server, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "D724668E-6AA6-43CF-936B-1BC0DF097B4A", Text1 = "2004 - May/June", Text2 = "The May/June issue of Component Developer Magazine (CoDe) is focused on security, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "BD037C83-7528-4D24-B5F2-D23AD20BAC84", Text1 = "2004 - March/April", Text2 = "The March/April issue of Component Developer Magazine (CoDe) is focused on performance and online content management with ASP.NET, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "8EFB21C1-C480-489B-914A-944B7AA7CFE0", Text1 = "2004 - January/February", Text2 = "The January/February issue of Component Developer Magazine (CoDe) is focused on the upcoming version of Visual Studio codenamed 'Whidbey', and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "542CF487-9E7E-4580-848C-7A19BEAEF26C", Text1 = "2003 - November/December", Text2 = "The November/December issue of Component Developer Magazine (CoDe) is focused on Database Development, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "2599DDAA-4632-4233-8ECA-33BF20399332", Text1 = "2003 - September/October", Text2 = "The September/October issue of Component Developer Magazine (CoDe) is focused on Mobile Application Development, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "361D8FD2-DA20-455A-8324-74D4FFAD7740", Text1 = "2003 - July/August", Text2 = "The July/August issue of Component Developer Magazine (CoDe) is focused on .NET Framework Classes, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "94E290F0-9827-4FE0-A6B8-369458E45ED4", Text1 = "2003 - May/June", Text2 = "The May/June issue of Component Developer Magazine (CoDe) is focused on GDI+, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "5B2EE158-320A-4A02-A3EC-A029DA6C87F1", Text1 = "2003 - March/April", Text2 = "The March/April issue of Component Developer Magazine (CoDe) is focused on Web Forms, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "B69D6B74-2588-4E21-BB83-9F6926EAD417", Text1 = "2003 - Jan/Feb", Text2 = "The January/February issue of Component Developer Magazine (CoDe) is focused on Windows Forms, and contains several in-depth articles focused on that subject, as well as several general .NET articles."},
                            new StandardViewModel {Identifier2 = "14A267A7-5749-4070-9F8B-12EC7C714DBB", Text1 = "2002 - Nov/Dec"},
                            new StandardViewModel {Identifier2 = "B228DCD4-63F2-44AE-A2B4-91183C884525", Text1 = "2002 - Sept/Oct"},
                            new StandardViewModel {Identifier2 = "CC1AA2AD-CC39-4681-9E8A-CABE37B76F9B", Text1 = "2002 - July/Aug"},
                            new StandardViewModel {Identifier2 = "5ACBDB69-CD67-456C-BA18-4D3936151142", Text1 = "2002 - May/June"},
                            new StandardViewModel {Identifier2 = "ADE031CE-CF08-45DD-BC02-7762D5833274", Text1 = "2002 - March/April"},
                            new StandardViewModel {Identifier2 = "D5D3942C-4625-4636-A6E9-BC907E30C887", Text1 = "2002 - Jan/Feb"},
                            new StandardViewModel {Identifier2 = "E8086C6C-3075-463E-871C-F9024461EDC8", Text1 = "2001 - Nov/Dec"},
                            new StandardViewModel {Identifier2 = "706A48C8-17F5-4489-B5FA-514D617D1E51", Text1 = "2001 - Issue 3"},
                            new StandardViewModel {Identifier2 = "DDC029CA-A493-4BE6-95A8-E960D8B143B2", Text1 = "2001 - Issue 2"},
                            new StandardViewModel {Identifier2 = "02AD16BF-A7E9-4243-9B5A-0870019F7762", Text1 = "2001 - Issue 1"},
                            new StandardViewModel {Identifier2 = "B8520F62-AE81-4E5A-8478-10710469C685", Text1 = "2000 - Fall", Text2 = ".NET Servers"},
                            new StandardViewModel {Identifier2 = "FAF16728-9B09-4132-8318-081100295746", Text1 = "2000 - Summer"},
                            new StandardViewModel {Identifier2 = "703897E9-F46F-4846-AE30-23052092B876", Text1 = "2000 - Spring"}
                        };
                    Thread.Sleep(5000);
                return result;
            }, result =>
            {
                Issues.Clear();
                foreach (var subscriber in result)
                {
                    subscriber.Image1 = new ImageBrush(new BitmapImage(new Uri("http://codemag.com/Magazine/Cover/" + subscriber.Identifier2))) {Stretch = Stretch.UniformToFill};
                    Issues.Add(subscriber);
                }
            }, this);
        }

        public ObservableCollection<StandardViewModel> Issues { get; set; }
        public IViewAction Search { get; set; }
        public string SearchText { get; set; }
        public string SearchText2 { get; set; }
        public string SearchText3 { get; set; }
    }
}
